import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import japanize_matplotlib

inflnm = input('File Name(*.csv) = ') 
data_frm = pd.read_csv(inflnm, encoding='shift_jis')
print(data_frm.keys().values)

X_name = input('X = ') 
X = data_frm[X_name].values  
Y_name = input('Y = ') 
Y = data_frm[Y_name].values  
N = len(X)

XY = np.vstack((X, Y))
Cs = np.cov(XY)            #   XとYの共分散行列
SDx = Cs[0][0]**0.5        #   Xの標準偏差
SDy = Cs[1][1]**0.5        #   Yの標準偏差
r = Cs[0][1] / (SDx*SDy)   #   XとYの相関係数
print('Sx =',SDx)
print('Sy =', SDy)
print('r  =', r)

a = r * SDy/SDx
b = np.mean(Y)
print('a =', a)
print('b =', b)
print(f'Reg.Line: Y = {a:.2f}*(X-Xmean) + {b:.2f}')
Xmean = np.mean(X)
Ymean = np.mean(Y)
print('Xmean =', Xmean)
print('Ymean =', Ymean)
Xmin = np.min(X)
Xmax = np.max(X)
plt.scatter(X, Y)
plt.xlabel(X_name, fontsize=14)
plt.ylabel(Y_name, fontsize=14)
plt.plot([Xmin, Xmax], [a*(Xmin - Xmean) + b, a*(Xmax - Xmean) +b],
         label='reg.line')
plt.plot([Xmean], [Ymean], marker='*', markersize=16,
         label=r'($\overline{X}$,$\overline{Y}$)')
plt.title(f'r = {r:.3f}, $R^2$ = {r**2:.3f}, reg.coef.={a:.3f}', fontsize=16)
plt.legend()
plt.tight_layout()
plt.show()
